﻿'Dans ce troisième tutorial nous allons aussi charger un objet 3d mais à partir
'd'un fichier et lui appliquer de la lumière
Imports Tzu3D
Imports Tzu3D.TZGlobal
Imports System.ComponentModel

Public Class Form1
    Private Engine As TZEngine
    Private Input As TZInput

    Private myScene As Scene.TZScene

    Private myCameraActor As Scene.TZActor
    Private myCamera As Tzu3D.Component.TZCamera

    Private OldWindowState As FormWindowState

    Private CP As Tzu3D.Component.TZCloudPoints
    Private myActor As Scene.TZActor

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Engine = TZEngine.Instance
        Input = TZInput.Instance

        Engine.Init(Me.Handle)
        Engine.Show_Fps = True

        Creating()

        Loading()

        Updating()

        Rendering()
    End Sub

    Private Sub Creating()
        Dim factor_test As Single = 1
        Dim point_Max_X As Integer = 1280
        Dim point_Max_Y As Integer = 720
        '921600 points !
        Dim Points(point_Max_X * point_Max_Y - 1) As Vector3

        'Create cloudPoints
        CP = New Tzu3D.Component.TZCloudPoints("myCloudPoints", Points.Count)
        CP.Size = 0.01F
        CP.Enable_Perspective = False
        CP.Color_0 = Color.Green
        CP.Color_1 = Color.Yellow
        CP.Color_2 = Color.Red
        CP.Color_3 = Color.Blue

        CP.Enable_Circle = True
        CP.MaxDepth = 4

        'random points
        Dim i As Integer
        For y As Integer = 0 To point_Max_Y - 1
            For x As Integer = 0 To point_Max_X - 1
                i = x + y * point_Max_X
                Points(i) = New Vector3(x * CP.Size * factor_test, y * CP.Size * factor_test, Rnd() * CP.MaxDepth)
            Next
        Next

        myActor = New Scene.TZActor("CloudPoints_Actor")
        myActor.Add_Component(CP)

        'send point to gpu
        CP.Set_Points(Points, 0, Points.Count)

        'add cp to scene
        myScene = New Scene.TZScene("myScene")
        myScene.Add(myActor)

        'tzu stuff
        myCamera = New Tzu3D.Component.TZCamera("myCamera")
        myCamera.Perspective(90, 16 / 9, 0.1, 100)
        myCamera.Projection_Mode = eCameraProjection.Perspective
        myCamera.Set_Mode(eCameraMode.First_Person)

        myCameraActor = New Scene.TZActor("myCameraActor")
        myCameraActor.Position = New Vector3(point_Max_X * CP.Size * factor_test * 0.5F, point_Max_Y * CP.Size * factor_test * 0.5F, -1)
        myCameraActor.Direction = New Vector3(0, 0, 1)

        myCameraActor.Add_Component(myCamera)

        myScene.Add(myCameraActor)
    End Sub

    Private Sub Loading()
        myScene.Load()


        Engine.Load()
    End Sub

    Private Sub Updating()

    End Sub

    Private Sub Rendering()
        Do While Engine.DoRender
            Engine.Render_Begin(Color.FromArgb(16, 16, 16))

            Controller()

            myScene.Process()

            myScene.Render()

            Engine.Render_End()

            Application.DoEvents()
        Loop

        CP.Dispose()
        Engine.Dispose()

        Application.Exit()
    End Sub
    Private MousePressed As Boolean = False
    Private MouseLocation As Vector2
    Private Sub Controller()
        If Input.Mouse_Buttons(eMouseButton.Button_2) Then
            If MousePressed = False Then
                MouseLocation = Input.Mouse_Position
                MousePressed = True
            Else
                myCameraActor.Position = myCamera.Position + New Vector3(0, 0, (Input.Mouse_Position.Y - MouseLocation.Y) * 0.002F)
                MouseLocation = Input.Mouse_Position
            End If
        Else
            MousePressed = False
        End If

        If Input.Key(Keys.Up) Then
            myCameraActor.Position = myCamera.Position + New Vector3(0, 0, 0.002F)
        ElseIf Input.Key(Keys.down) Then
            myCameraActor.Position = myCamera.Position + New Vector3(0, 0, -0.002F)
        End If
    End Sub

    Private Sub Form1_Closing(sender As Object, e As CancelEventArgs) Handles Me.Closing
        If Engine.DoRender Then
            Engine.Quit()
            e.Cancel = True
        End If
    End Sub

    Private Sub Form1_ResizeEnd(sender As Object, e As EventArgs) Handles Me.ResizeEnd
        If Engine Is Nothing Then Exit Sub
        Engine.Resize_Windows()
    End Sub


    Private Sub Form1_SizeChanged(sender As Object, e As EventArgs) Handles Me.SizeChanged
        If Engine Is Nothing Then Exit Sub
        If Me.WindowState = FormWindowState.Maximized OrElse Me.WindowState = FormWindowState.Normal Then
            If OldWindowState <> Me.WindowState Then
                Engine.Resize_Windows()
                OldWindowState = Me.WindowState
            End If
        End If
    End Sub
End Class
