﻿Imports Tzu3D

Public Class Tutorial_04
    Private Engine As TZEngine
    ' Private Input As TZInput
    Private CanRender As Boolean = True
    Private OldWindowState As FormWindowState

    Private Sub Game_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Engine = TZEngine.Instance
        Engine.Debug_Enable = True
        ' Input = TZInput.Instance

        Engine.Init(Handle)
        Engine.Thread_Max = Environment.ProcessorCount - 1
        '  Input.AddEventInThread()
        Engine.Show_Fps = True

        Rendering()
    End Sub

    Private Sub Rendering()
        Do While Engine.DoRender
            Engine.Render_Begin(Color.Black)
            Engine.Render()
            Engine.Render_End()
            Application.DoEvents()
        Loop

        Engine.Dispose()

        Application.Exit()
    End Sub

    Private Sub App_ResizeBegin(sender As Object, e As EventArgs) Handles Me.ResizeBegin
        CanRender = False
    End Sub

    Private Sub App_ResizeEnd(sender As Object, e As EventArgs) Handles Me.ResizeEnd
        ResizeRender()
    End Sub

    Public Sub ResizeRender()
        Engine.Resize_Windows()
    End Sub

    Private Sub App_SizeChanged(sender As Object, e As EventArgs) Handles Me.SizeChanged
        If Engine Is Nothing Then Exit Sub

        If Me.WindowState = FormWindowState.Maximized OrElse Me.WindowState = FormWindowState.Normal Then
            If OldWindowState <> Me.WindowState Then
                ResizeRender()
                OldWindowState = Me.WindowState
            End If

        End If
    End Sub

    Private Sub Game_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing
        If Engine.DoRender Then
            Engine.Quit()
            e.Cancel = True
        End If
    End Sub
End Class
